<?track_vars?>
<?php

/* Copyright (C) 2000,2001 Mandrakesoft                                  */
/* Authors :                                                             */
/* Enzo Maggi <emaggi@mandrakesoft.com>                                  */
/* Renaud Chaillat <rchaillat@mandrakesoft.com>                          */
/* Philippe Libat <philippe@mandrakesoft.com>                            */
/*                                                                       */
/* $Id: functions.php,v 1.4 2002/12/04 13:04:19 philippe Exp $ */

/*
 Copyright (C) 2002 MandrakeSoft SA
 
 This program may be distributed and/or
 modified under the terms of the GNU General Public
 License version 2 as published by the Free Software Foundation
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 General Public License for more details.
 
 Licensees holding valid MandrakeSecurity MNF Commercial License may use this
 file in  accordance with the MandrakeSecurity MNF Commercial License Agreement
 provided with the Software.
 
 See http://www.mandrakesoft.com/mnf/license for information about MandrakeSecurity MNF Commercial License Agrrement.
*/ 

/**
 utilies for handling the data of a naat program */

/* temp file for status file */
//  define("VARDIR","../sesssions/");

/**
	generate the name of stack file  $md5.STATUS
 **/
  function status_id_file()
  {
/*    global $md5;
    global $stack_file;
*/
 global $md5;
    $stack_file=VARDIR.$md5.".status";
    return $stack_file;
  }

/*
	 create a file like stack file (STATUS.$md5)
 */
  function create_file ($file)
  {
    if ( !file_exists ($file) ) 
      {
	$status_file =  fopen ($file, 'w+');
	chmod ($file, 0600);
      } 
    else 
      {
	$status_file =  fopen ($file, 'r');
      }
    return $status_file;
  }

/**
	delete a file like STATUS.$md5
**/
  function delete_file ($file)
  {
    if ( file_exists ($file) ) 
      { 
	return unlink($file);
      }
    return 0;
  }

  function vm_reset()
  {
    global $ACC;
    global $PC;
    global $SP;
    global $CT;
    global $HSP;

    $ACC=0;
    $PC=1;
    $SP=0;

    $CT=0;
    $HSP=0;
  }

/* history stack */
  function history_push()
  {
    global $history_stack;
    global $ACC;
    global $HSP;
    global $CT;

    // Increment the counter for displayed pages,
    // even if it's the same page.
    $CT += 1;

    // Don't append the current page to the history 
    // if it's already on top (i.e. we loop on the current page)
    if ( $history_stack [(int) ($HSP - 1)] != $ACC)
      {
	$history_stack[(int) $HSP] = $ACC;
	$HSP += 1;
      }
  }

  function history_pop()
  {
    global $history_stack;
    global $ACC;
    global $HSP;
    global $CT;

    if ($HSP == 0) return 0; //empty history stack

    $ACC = $history_stack[(int) ($HSP - 1)];
    $HSP -= 1;

    // Do not touch the CT counter here

    return 1;
  }


/* stack. */
  function push()
  {
    global $stack;
    global $ACC;
    global $SP;

    $stack[(int) $SP] = $ACC;
    $SP += 1;
  }

  function pop()
  {
    global $stack;
    global $ACC;
    global $SP;

    if ($SP == 0) return 0; //empty stack
    $ACC = $stack[(int) ($SP - 1)];
    $SP -= 1;
    return 1;
  }

  function gotoLine($progCounter)
  {
    global $table_file;
    $i=0;

    fseek($table_file, 0);
    for ($i = 0; $i < $progCounter - 1 ; $i++)
      fgets($table_file, 4096);
    
  }

  function next_token()
    {
      global $table_file;
      $c = "";
      $d = "";

      
      $d = fgetc($table_file);
      while( ! feof($table_file) && $d != "\t" && $d != "\n") {
	$c .= $d;
	$d = fgetc($table_file);
      }

      return $c;
    }


  /* The state is stored in a file called STATUS.$md5, as follows:
   * PC
   * ACC
   * SP
   * stack[0]
   * stack[1]
   * ...
   * The displayed pages history is stored in HISTORY.$md5, as follows:
   * CT  (counter for number of pages displayed since cmd=start)
   * HSP
   * history_stack[0]
   * history_stack[1]
   * ...
   */
  function load_state()
  {
    global $file; // xxx.wvm posted by the form
    global $table_file;
    global $status_file;

    global $PC;
    global $ACC;
    global $SP;

    global $stack_file;

    /** Opens the needed files */

    load_history_stack ();

    //  File contains navigation: table_file (*.wvm)
    //if (file_exists($file)){ $table_file = fopen ($file, 'r'); } else {exit;}
   $table_file = @fopen ($file, 'r');	// ################## Ugly : please fixme ###################
    //if (!$table_file) { exit; }
    if (!$table_file) header("Location: index.php?warning=1");

    // STACK
    $stack_file=status_id_file();

    $status_file = create_file($stack_file); 

    $PC=fgets($status_file, 128);
    $ACC=fgets($status_file, 128);
    $SP=fgets($status_file, 128);

    load_stack();
  }

  /* The state is stored in a file called $md5.STATUS, as follows:
   * PC
   * ACC
   * SP
   * stack[0]
   * stack[1]
   * ...
   */
  function save_state()
  {
    global $table_file;
    global $status_file;

    global $PC;
    global $ACC;
    global $SP;

    global $stack_file;
    global $history_file;

    $stack_file = status_id_file ();

    fclose ($status_file);
    $status_file = fopen ($stack_file, 'w');

    fwrite($status_file, trim($PC) . "\n") ;
    fwrite($status_file, trim($ACC) . "\n") ;
    fwrite($status_file, trim($SP) . "\n") ;

    save_stack ();
    save_history_stack ();
    
    fclose ($table_file);
    fclose ($status_file);
    fclose ($history_file);
  }


// the stack is read into memory. status_file should be positioned at the good point.
  function load_stack()
  { 
    global $status_file;

    global $SP;
    global $stack;

    for ($i = 0; $i < $SP ; $i++)
      {
	$str = fgets($status_file, 4096);    
	$str = chop ($str);
//	$stack[(int) $i] = substr($str, 0, strlen($str) - 1); //skip trailing '\n'
      }
  }


  function save_stack()
  { 
    global $status_file;

    global $SP;
    global $stack;

    $str = "";

    for ($k = 0; $k < $SP ; $k++) 
      {
	$str = strval($stack[$k]);
	fwrite($status_file, trim($str) . "\n");
	  
      }
  }



  /*
   * The displayed pages history is stored in HISTORY.$md5, as follows:
   * HSP
   * history_stack[0]
   * history_stack[1]
   * ...
   */
  function load_history_stack()
  { 
    global $history_filename;
    global $history_file;

    global $CT;
    global $HSP;
    global $history_stack;
  global $md5;

    $history_filename = VARDIR.$md5.".history";

    // Create the file it it does not exist, else 
    // open it for reading
    $history_file = create_file ($history_filename); 
    if ( !$history_file ) { exit; }

	// context ('where')
	global $where;
	$where_read = fgets ($history_file, 4096);
	$where_read = chop ($where_read);
	if ( !$where ) $where = $where_read;

    // wvm filename
    $wvm_name = fgets ($history_file, 4096);
    // Check if $file  (the *.wvm file) exists (normal situation), 
    // else set the one read in the history.
    global $file;
    if ( !$file ) 
      {
	$file = $wvm_name;
      }

    // name of the last page (not used in the engine, but by admin/index.php)
    fgets ($history_file, 4096);

    // displayed pages counter (tag)
    $CT = fgets ($history_file, 128);
    if ( !$CT ) 
      { 
	$CT  = 0;
	$HSP = 0;
	return;
      }

    // history stack pointer
    $HSP= fgets ($history_file, 128);

    // Then the history stack data
    for ($i = 0; $i < $HSP ; $i++)
      {
	$str = fgets ($history_file, 4096);    
	$history_stack [(int) $i] = substr ($str, 0, strlen($str) - 1); //skip trailing '\n'
      }
  }


  function save_history_stack()
  { 
    global $history_file;
    global $history_filename;

    global $file;
    global $last_page;
    global $CT;
    global $HSP;
    global $history_stack;


    // Reopen the file with write access
    fclose ($history_file);
    $history_file = fopen ($history_filename, 'w');

	// Save the context ('where')
    global $where;
    fwrite ($history_file, trim($where) . "\n") ;

	// Save the wvm name
    fwrite ($history_file, trim($file) . "\n") ;

	// Save the last url
    fwrite ($history_file, trim($last_page) . "\n") ;

	// Save the tag counter and the history stack pointer
    fwrite ($history_file, trim($CT) . "\n") ;
    fwrite ($history_file, trim($HSP) . "\n") ;

    // Save the history stack data 
    $str = "";
    for ($k = 0; $k < $HSP ; $k++) 
      {
	$str = strval ($history_stack[$k]);
	fwrite ($history_file, trim($str) . "\n");
      }
  }


?>
