<?php_post_vars?>
<?php

/* Copyright (C) 2000,2001 Mandrakesoft                                  */
/* Authors :                                                             */
/* Enzo Maggi <emaggi@mandrakesoft.com>                                  */
/* Renaud Chaillat <rchaillat@mandrakesoft.com>                          */
/*                                                                       */
/* $Id: interpreter.php,v 1.3 2002/12/04 13:04:19 philippe Exp $        */

/*
 Copyright (C) 2002 MandrakeSoft SA
 
 This program may be distributed and/or
 modified under the terms of the GNU General Public
 License version 2 as published by the Free Software Foundation
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 General Public License for more details.
 
 Licensees holding valid MandrakeSecurity MNF Commercial License may use this
 file in  accordance with the MandrakeSecurity MNF Commercial License Agreement
 provided with the Software.
 
 See http://www.mandrakesoft.com/mnf/license for information about MandrakeSecurity MNF Commercial License Agrrement.
*/ 
/**
 * This file cannot be used alone. It uses functions coming from functions.php,
 * and does not "require" it because of a possible double-inclusion problem of php.
 * Use this file in a main files that includes functions.php and interpreter.php in this order */

require("interpreter/php_libs/utils.php");

function fetch()
{
  global $PC;
  global $lineNo;
  global $instruction;

  gotoLine($PC);

  $lineNo = next_token();
  $instruction = next_token();
}

function step()
{
  global $PC;
  global $ACC;
  global $DEBUG;
  global $lineNo;
  global $instruction;
  global $stack;
  global $last_page;

  global $HTTP_POST_VARS;
  global $md5; // Transaction ID set by index.php

  // First get global parameters in case we need it
  for ($i=1; $i<20; $i++) 
    {
      $param_name = "frontend_param$i";
      global $$param_name;
      
      // Try in posted vars if not global
      if ( !$$param_name || $$param_name=="" ) 
	{
	  $$param_name = $HTTP_POST_VARS[$param_name];
	}

      // Stringify if it's an arry (turn into comma separated list)
      if ( is_array ($$param_name) ) 
	{
	  $string_list = stringify_array ($$param_name);
	  $$param_name = $string_list;
	}

      // replace ' ' by %20 to $$param_name could be used for header again.
      //$$param_name = str_replace(' ', '%20', $$param_name);
    }

  switch ($instruction)
    {
    case "IF":
      $_stat = next_token();
      $_then = next_token();
      $_else = next_token();

      if ( $ACC == $_stat )
	$PC = $_then;
      else
	$PC = $_else;

      break;
	
    case "EXEC":
      $function = next_token();

      // Get the optional function arguments
      $args = explode (' ', $function);

      // Is it a frontend function or an external one ?
      $internal = preg_match("/^frontend_/",$function);
      if ( $internal ) 
	{
	  // Isolate the function name from its arguments
	  $function = $args[0]; 
	  // Call the frontend function with or without args array
	  if ( count($args) ) 
	    {
	      array_shift ($args);
	      $var = $function ($args);
	    } 
	  else 
	    {
	      $var = $function ();
	    }
	} 
      else 
	{
	  // Here $function is the complete stringified command 
	  // with arguments
	  // We have to perform an eval on this string to get 
	  // the transaction ID and get the real name of compound
	  // variables (for now, we only support compound variable using a 
	  // a frontend parameter here; e.g. ${frontend_param1}IP )
	  eval ("\$function = \"$function\";");
	  exec ($function, &$arr, &$var);
	}

      // Update context
      $ACC = $var;
      $PC += 1;
      break;
	
    case "PUSH":

      push();
      $PC += 1;
      break;
	
    case "POP":
	
      pop();
      $PC += 1;
      break;
	
    case "GOTO":
      $PC = next_token();
    break;
      

    // TODO: HISTORY STACK

    case "SHOW":
      {  
	$ACC = $PC;
	// push();
	history_push ();
	$PC += 1;
	$last_page = next_token() . ".php";

	// Process parameters for the page (frontend variables)
	$i = 1; 
	while ($i < 20) // 19 parameters max in a page
	  { 
	    $varname = "frontend_param$i";
	    $param = $$varname;
	    
	    // Handle lists of values (from checkbox lists for instance)
/* shouldn't be necessary anymore (done above)
	    if ( is_array ($param) ) 
	      {
		$string_list = stringify_array ($param);
		unset($param);
		$param = $string_list;
	      }
*/

	    // Append param to URI
	    if ( $param != "" ) 
	      {
		$last_page .= "&frontend_param$i=$param";
	      }
	    
	    $i++;
	  }
	
	// Tell the container (index.php) to display the page
	// We have to propagate the context ('where' variable)
	// We add a 'tag' (the CT counter) to the page to handle the browser back & forward buttons
	global $where;
	global $CT;


	//$fp = fopen ("/home/stilly/debug", "w+");

	if ( $where ) $where_str = "where=".$where."&";
	if ( $CT )    $tag_str   = "tag=".$CT."&";
	if ( $DEBUG !=1 ) header("Location: index.php?".$where_str.$tag_str."loadfile=". $last_page);

	//	fwrite( $fp, header("Location: index.php?".$where_str.$tag_str."loadfile=". $last_page) );

	return "end";

      }
      break;

    case "HALT":
      {
	$PC=-1;
	return "end";
      }

    }

  return "go";
}


function _next()
{
  global $instruction;
  global $lineNo;
  global $PC;
  global $last_page;
  global $where;
  global $md5; // Transaction ID set by index.php

  if ( $PC == -1 ) 
    {
      if ( $where ) { $where_str = "where=".$where."&"; }
      header("Location: index.php?".$where_str."loadfile=" . $last_page);
    }

  // ---- Main loop ----
  while (step() == "go")
    {
      fetch();
    }
  // -------------------

  if ( $PC == -1 ) 
    {
      if ( $where ) { $where_str = "where=".$where."&"; }
      header("Location: index.php?".$where_str."loadfile=" . $last_page);
    }
  
}
?>
